<!DOCTYPE html>
<html>

<head>
    <meta charset='utf-8'>
    <title>orderDetail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL_ORDERS = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gBASE_URL_DRINKS = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
    const vFORM_LIST = "indexListView.html";
    //đối tượng 
    var gId;
    var gOrderCode;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện tải trang
    function onPageloading() {
        "use strict"
        //Tạo đối tượng 
        var vUrlString = window.location.href;
        console.log(vUrlString);
        var vUrl = new URL(vUrlString);

        gId = vUrl.searchParams.get("id");
        gOrderCode = vUrl.searchParams.get("orderCode");

        //B2: validate data
        if (gId == null || gId == "") {
            alert("Không có Id đơn hàng. Vui lòng kiểm tra lại");
            window.location.href = vFORM_LIST;
        }
        else if (gOrderCode == null || gOrderCode == "") {
            alert("không có OrderCode");
            window.location.href = vFORM_LIST;
        }
        //ghi các biến global tra console
        console.log("id: " + gId);
        console.log("Order code (mã đơn): " + gOrderCode);
        //Load dữ liệu vào selector
        LoadDataDrinkToForm();
        //B3: gọi API
        callAPIOrderdata(gOrderCode);
    }

    //Hàm xử lý khi click nút Confirm
    function onBtnConfirmClick() {
        console.log("Id Order: " + gId);
        //Khai báo đối tượng
        var vStatusObj = {
            trangThai: "confirmed"
        }
        //gọi API
        callAPIUpdateOrderdata(vStatusObj);
    }

    //hàm xử lý khi nhấn nút cancel
    function onBtnCancelclick() {
        console.log("Id Order: " + gId);
        //Khai báo đối tượng
        var vStatusObj = {
            trangThai: "Canel"
        }
        //gọi API
        callAPIUpdateOrderdata(vStatusObj);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi API update đơn hàng
    function callAPIUpdateOrderdata(paramStatusObj) {
        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        vXmlHttpUpdateOrder.open("PUT", gBASE_URL_ORDERS + "/" + gId);
        vXmlHttpUpdateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        vXmlHttpUpdateOrder.send(JSON.stringify(paramStatusObj));
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                    //hiển thị thông tin
                    console.log(vUpdatedOrder);
                    if (vUpdatedOrder.length > 0) {
                        alert("cập nhật thành công");
                        var vUrl = vFORM_LIST;
                        window.location.href = vFORM_LIST
                    }
                }
            }
    }

    //Hàm xử lý đổ dữ liệu vào selector đồ uống bằng cách gọi một API
    function LoadDataDrinkToForm() {
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET", gBASE_URL_DRINKS, true);
        vXhttp.send();
        vXhttp.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    handleDataToSelectdrink(vXhttp);
                }
            };
    };
    //hàm hiển thị đồ uống vào option
    function handleDataToSelectdrink(paramXMLHttp) {
        var vResponseText = paramXMLHttp.responseText;
        //console.log(vResponseText);
        var vListDrinks = JSON.parse(vResponseText);
        //console.log(vListDrinks);

        var vElementDrinkSelect = document.getElementById("select-idLoaiNuocUong");
        //duyệt dữ liệu đổ vào selector với forr
        for (var bI = 0; bI < vListDrinks.length; bI++) {
            var bDrinkOption = document.createElement("option");
            bDrinkOption.value = vListDrinks[bI].maNuocUong;
            bDrinkOption.text = vListDrinks[bI].tenNuocUong;
            vElementDrinkSelect.appendChild(bDrinkOption);
        }
    }
    // hàm gọi API lấy thông tin dơn hàng
    function callAPIOrderdata(paramOderCode) {
        var vXmlHttpGetOrderById = new XMLHttpRequest();
        vXmlHttpGetOrderById.open("GET", gBASE_URL_ORDERS + "/" + paramOderCode, true);
        vXmlHttpGetOrderById.send();
        vXmlHttpGetOrderById.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    //B4: Xử lý hiển thị dữ liệu lên form
                    //console.log(vXmlHttpGetOrderById.responseText);
                    showDataToForm(vXmlHttpGetOrderById);
                }
            }

    }
    //Hàm xử lý hiển thị lên form
    function showDataToForm(paramXMLHttp) {
        var vOrderObj = JSON.parse(paramXMLHttp.responseText);

        //console.log(paramXMLHttp.responseText)
        var vOrderCode = document.getElementById("input-orderCode");
        var vSizeCombo = document.getElementById("select-kichCo");
        var vDuongKinh = document.getElementById("input-duongKinh");
        var vsuonnuong = document.getElementById("input-suon");
        var vDoUong = document.getElementById("select-idLoaiNuocUong");
        var vSoLuongNuoc = document.getElementById("input-soLuongNuoc");
        var vVoucherId = document.getElementById("input-idVourcher");
        var vLoaiPizza = document.getElementById("select-loaiPizza");
        var vSalad = document.getElementById("input-salad");
        var vThanhTien = document.getElementById("input-thanhTien");
        var vGiamGia = document.getElementById("input-giamGia");
        var vHoTen = document.getElementById("input-hoTen");
        var vEmail = document.getElementById("input-email");
        var vPhone = document.getElementById("input-soDienThoai");
        var vAddress = document.getElementById("input-diaChi");
        var vLoiNhan = document.getElementById("input-loiNhan");
        var vStatus = document.getElementById("select-trangThai");
        var vNgayTao = document.getElementById("input-ngayTao");
        var vNgayCapNhat = document.getElementById("input-ngayCapNhat");

        //show dữ liệu lên form
        vOrderCode.value = vOrderObj.orderCode;
        vSizeCombo.value = vOrderObj.kichCo;
        vDuongKinh.value = vOrderObj.duongKinh;
        vsuonnuong.value = vOrderObj.suon;
        vDoUong.value = vOrderObj.idLoaiNuocUong;
        vSoLuongNuoc.value = vOrderObj.soLuongNuoc;
        vVoucherId.value = vOrderObj.idVourcher;
        vLoaiPizza.value = vOrderObj.loaiPizza;
        vSalad.value = vOrderObj.salad;
        vThanhTien.value = vOrderObj.thanhTien;
        vGiamGia.value = vOrderObj.giamGia;
        vHoTen.value = vOrderObj.hoTen;
        vEmail.value = vOrderObj.hoTen;
        vPhone.value = vOrderObj.soDienThoai;
        vAddress.value = vOrderObj.diaChi;
        vLoiNhan.value = vOrderObj.loiNhan;
        vStatus.value = vOrderObj.trangThai;
        vNgayTao.value = vOrderObj.ngayTao;
        vNgayCapNhat.value = vOrderObj.ngayCapNhat;
    }

    //
</script>

<body onload="onPageloading()">
    <div class="container">
        <h1 class="text-center text-success">Order Detail</h1>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Order Code</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-orderCode">
            </div>
            <div class="col-2 text-right">
                <label>Cỡ Combo</label>
            </div>
            <div class="col-4">
                <select id="select-kichCo" class="form-control">
                    <option value="Select-combo">Chọn Cỡ Combo (Combo size)</option>
                    <option value="S">Nhỏ</option>
                    <option value="M">Vừa</option>
                    <option value="L">Lớn</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Đường kính Pizza</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-duongKinh">
            </div>
            <div class="col-2 text-right">
                <label>Sườn nướng(miếng)</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-suon">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Đồ uống</label>
            </div>
            <div class="col-4">
                <select class="form-control" id="select-idLoaiNuocUong">
                    <option value="select-drink">Chọn đồ uống</option>
                </select>
            </div>
            <div class="col-2 text-right">
                <label>Số lượng nước uống</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-soLuongNuoc">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Voucher ID</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-idVourcher">
            </div>
            <div class="col-2 text-right">
                <label>Loại Pizza</label>
            </div>
            <div class="col-4">
                <select class="form-control" id="select-loaiPizza">
                    <option value="select-pizza">Chọn loại Pizza</option>
                    <option value="SEAFOOD">Hải sản</option>
                    <option value="HAWAII">Hawaii</option>
                    <option value="BACON">Thịt hun khói</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Salad</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-salad">
            </div>
            <div class="col-2 text-right">
                <label>Thành tiền</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-thanhTien">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Giảm giá</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-giamGia">
            </div>
            <div class="col-2 text-right">
                <label>Họ và tên</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-hoTen">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Email</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-email">
            </div>
            <div class="col-2 text-right">
                <label>Số điện thoại</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-soDienThoai">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Địa chỉ</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-diaChi">
            </div>
            <div class="col-2 text-right">
                <label>Lời nhắn</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-loiNhan">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Trạng thái đơn hàng</label>
            </div>
            <div class="col-4">
                <select class="form-control" id="select-trangThai">
                    <option value="select-trạng-thái">Trạng thái</option>
                    <option value="open">Open</option>
                    <option value="confirmed">Confirm</option>
                    <option value="cancel">Cancel</option>
                </select>
            </div>
            <div class="col-2 text-right">
                <label>Ngày tạo đơn</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-ngayTao">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Ngày cập nhật</label>
            </div>
            <div class="col-4">
                <input class="form-control" id="input-ngayCapNhat">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-4" style="margin-left:30% ;">
                <button onclick="onBtnConfirmClick()" class="btn btn-group btn-primary" id="confirm">Confirm</button>
                <button onclick="onBtnCancelclick()" class="btn btn-group btn-info" id="cancel">Cancel</button>
            </div>
        </div>
    </div>
</body>

</html>